package com.superversion.rasa.service.impl;

import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONUtil;
import com.superversion.rasa.pojo.dto.RasaReqDTO;
import com.superversion.rasa.pojo.dto.RasaResDTO;
import com.superversion.rasa.service.RasaTalkService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;
@Service
@Slf4j
@RequiredArgsConstructor
public class RasaTalkServiceImpl implements RasaTalkService {

    @Value("${rasa.url}")
    private String rasaUrl;
    @Override
    public List<String> talkRasa(String question, String sessionId) {

        RasaReqDTO rasaReqDTO = new RasaReqDTO();
        rasaReqDTO.setSender(sessionId);
        rasaReqDTO.setMessage(question);
        String post = HttpUtil.post(rasaUrl, JSONUtil.toJsonStr(rasaReqDTO));
        List<RasaResDTO> list = JSONUtil.toList(post, RasaResDTO.class);
        return list.stream().map(RasaResDTO::getText).collect(Collectors.toList());
    }
}
